/**
 * Resolution method able to decide fol-representations of ALB-knowledge bases
 *
 * Taken from "Issues of Decidability for Description Logics in the Framework of Resolution",
 * Ullrich Hustadt and Renate A. Schmidt, 2000, in In Caferra, R. and Salzer, G. (eds), 
 * Automated Deduction in Classical and Non-Classical Logic, Lecture Notes in Artificial Intelligence, 
 * Vol. 1761, Springer, 191-205. 
 */

package uk.ac.man.cs.lethe.internal.resolution

import uk.ac.man.cs.lethe.internal.resolution.orderings.GuardedFragmentOrdering

import uk.ac.man.cs.lethe.internal.fol.datatypes._
import uk.ac.man.cs.lethe.internal.normalForms.DefinitionalCNFSingleton

import com.typesafe.scalalogging.Logger

object AlbFolProver extends OrderedResolutionProver()(GuardedFragmentOrdering) { 
//  override val (logger, formatter, appender) =
//  ZeroLoggerFactory.newLogger(this)
  override val logger = Logger(AlbFolProver.getClass)

  // override def setFormula(formula: Formula) =
  //   setClauses(DefinitionalCNFSingleton.clauses(formula))

  def lastClauseSet = clauses
}

